#ifndef ANNOTATE_H
#define ANNOTATE_H

#include <vector>


typedef struct {
    unsigned int label;
    unsigned int numPixels;
//    bool         covered;
    unsigned int maxRow;
    unsigned int minRow;
    unsigned int medianRow;
    unsigned int maxCol;
    unsigned int minCol;
    unsigned int medianCol;
} RegionInfo;

typedef struct {
    int row;
    int col;
    unsigned int label;
//    unsigned int closestStateVector;
} PixelInRegion;

template <typename T, unsigned int CHANNELS>
struct ColouredPixel : PixelInRegion {
    ColouredPixel(const PixelInRegion & p) : PixelInRegion(p) {
        for (unsigned int c = 0 ; c < CHANNELS ; ++c) {
            this->colour[c] = 255;
        }
    }
    T colour[CHANNELS];
};

//template <typename T>
//unsigned int labelImage(unsigned int   numMaxRegions,
//                        RegionInfo     regionInfo[], // [numMaxRegions + 1]
//                        unsigned int * labelled,
//                        const T      * binary,
//                        unsigned int   imageHeight,
//                        unsigned int   imageWidth);

template <typename T>
unsigned int linearLabelImage(
        unsigned int numMaxRegions,
        RegionInfo      regionInfo[],//[numMaxRegions + 1],
        unsigned int   minRegionSize,
        std::vector<PixelInRegion>  & pixelsInConformingRegions,
        const T      * probBG,
        unsigned int   imageHeight,
        unsigned int   imageWidth);



#endif // ANNOTATE_H
