#ifndef OUTPUTSTAGE_H
#define OUTPUTSTAGE_H

#include "stage.h"
#include "ioconfig.h"
#include "imagedimensions.h"
#include "circularbuffertracker.h"

//class InputStage : public Stage
//{
//public:
//    InputStage (IOConfig *config, Stage *next);
//    virtual ~InputStage ();
//    virtual std::ptrdiff_t startWrite () { return -1; }
//    virtual void endWrite (std::ptrdiff_t /* written */ ) {}
//    virtual void notifyEndOfStream () {}
//    virtual cudaArray* initializeBuffer (unsigned int, unsigned int, unsigned int) { return NULL; }
//    virtual cudaArray* initializeBuffer (ImageDimensions const & /* dim */) { return NULL; }

//protected:
//    virtual void run ();
//    void initialize();
//private:
//    InputStage ();
//    IOConfig const config;
//    ImageDimensions imageDim;
//    cudaArray *originalInputArray;
//    cudaArray *normalizedFloatArray;
//    cudaArray *nextStageArray;
//    unsigned char **originalPinnedChannels;
//};

class OutputStage : public Stage
{
public:
    OutputStage (const IOConfig & config, Stage *next = NULL);
    virtual ~OutputStage ();
    virtual std::ptrdiff_t startWrite ();
    virtual void endWrite (std::ptrdiff_t written);
    virtual void notifyEndOfStream ();
    virtual cudaArray* initializeBuffer (unsigned int width, unsigned int height, unsigned int channels);
    virtual cudaArray* initializeBuffer (ImageDimensions const &dim);

protected:
    virtual void run ();
    void initialize();

private:
    OutputStage();
    virtual cudaArray* initializeBuffer ();


    CircularBufferTracker tracker;
    IOConfig const config;
    ImageDimensions imageDim;
    cudaArray *outputImagesArray;
};

#endif // OUTPUTSTAGE_H
