#-------------------------------------------------
#
# Project created by QtCreator 2013-04-17T16:30:33
#
#-------------------------------------------------



QT       += core

QT       -= gui

TARGET = qtmod
CONFIG   += console
CONFIG   -= app_bundle

TEMPLATE = app

HEADERS += \
    stage.h \
    inputstage.h \
    circularbuffertracker.h \
    processingstage.h \
    auxcuda.h \
    ioconfig.h \
    processingconfig.h \
    imagedimensions.h \
    inputstagecuda.h \
    scalarutils.h \
    processingstagecuda.h \
    outputstage.h \
    snd.h \
    deadcode.h \
    thumbnail.h \
    label.h \
    particleset.h \
    processingdatatypes.h \
    tinymt32.h \
    statevectorsset.h \
    prettyprintstl.h \
    ziggurat.h \
    particlefilter.h \
    particlefiltercuda.h \
    linearforegroundmodel.h \
    compiletimeconfig.h \
    filesystem.h

SOURCES += \
    main.cpp \
    inputstage.cpp \
    circularbuffertracker.cpp \
    processingstage.cpp \
    auxcuda.cpp \
    ioconfig.cpp \
    outputstage.cpp \
    thumbnail.cpp \
    label.cpp \
    particleset.cpp \
    processingdatatypes.cpp \
    tinymt32.cpp \
    statevectorsset.cpp \
    ziggurat.cpp \
    particlefilter.cpp \
    processingconfig.cpp \
    filesystem.cpp

#QMAKE_CXXFLAGS *= -std=c++11

# This makes the .cu files appear in your project
OTHER_FILES += inputstagecuda.cu scalarutils.cu processingstagecuda.cu particlefiltercuda.cu

# CUDA settings <-- may change depending on your system
CUDA_SOURCES += inputstagecuda.cu processingstagecuda.cu particlefiltercuda.cu
CUDA_SDK = "/opt/cuda/4.2.9"   # Path to cuda SDK install
CUDA_DIR = "/opt/cuda/4.2.9"            # Path to cuda toolkit install

# DO NOT EDIT BEYOND THIS UNLESS YOU KNOW WHAT YOU ARE DOING....

SYSTEM_NAME = unix         # Depending on your system either 'Win32', 'x64', or 'Win64'
SYSTEM_TYPE = 64            # '32' or '64', depending on your system
CUDA_ARCH = sm_21           # Type of CUDA architecture, for example 'compute_10', 'compute_11', 'sm_10'
#NVCC_OPTIONS = --ptxas-options=-v -gencode arch=compute_20,code=sm_20 -m64 -ccbin /usr/bin/g++-4.6
NVCC_OPTIONS = --ptxas-options=-v -v -arch=sm_20 -m64 -ccbin /usr/bin/g++-4.6

# include paths
INCLUDEPATH += $$CUDA_DIR/include # Viven en /usr/include con los demas
#INCLUDEPATH += /usr/include
#INCLUDEPATH += /usr/lib/nvidia-cuda-toolkit/include

# library directories
QMAKE_LIBDIR += $$CUDA_DIR/lib64 # Viven en /usr/lib con los demas

# CUDA_OBJECTS_DIR = ./


# Add the necessary libraries
CUDA_LIBS = -lcudart

# The following makes sure all path names (which often include spaces) are put between quotation marks
CUDA_INC = $$join(INCLUDEPATH,'" -I"','-I"','"')
#LIBS += $$join(CUDA_LIBS,'.so ', '', '.so')
LIBS += $$CUDA_LIBS -lfreeimageplus -lboost_filesystem -lboost_system

# Configuration of the Cuda compiler
CONFIG(debug, debug|release) {
    # Debug mode
    cuda_d.input = CUDA_SOURCES
    cuda_d.output = ${QMAKE_FILE_BASE}_cuda.o
    #cuda_d.commands = nvcc -D_DEBUG $$NVCC_OPTIONS $$CUDA_INC $$NVCC_LIBS --machine $$SYSTEM_TYPE -arch=$$CUDA_ARCH -c -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_NAME}
    cuda_d.commands = $$CUDA_DIR/bin/nvcc -g -D_DEBUG $$NVCC_OPTIONS $$CUDA_INC $$NVCC_LIBS -c -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_NAME} 2>&1 | sed -e \'s/\(\\\([0-9]\\+\\\)\):/:\1:1:/\' 1>&2
    cuda_d.dependency_type = TYPE_CXX
    QMAKE_EXTRA_COMPILERS += cuda_d
}
else {
    # Release mode
    cuda.input = CUDA_SOURCES
    cuda.output = ${QMAKE_FILE_BASE}_cuda.o
    cuda.commands = $$CUDA_DIR/bin/nvcc $$NVCC_OPTIONS $$CUDA_INC $$NVCC_LIBS -c -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_NAME} 2>&1 | sed -e \'s/\(\\\([0-9]\\+\\\)\):/:\1:1:/\' 1>&2
    cuda.dependency_type = TYPE_CXX
    QMAKE_EXTRA_COMPILERS += cuda
}

message (INCLUDEPATH: $$INCLUDEPATH)



